/* CPU data header for ubicom32.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright 1996-2007 Free Software Foundation, Inc.

This file is part of the GNU Binutils and/or GDB, the GNU debugger.

   This file is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   It is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.

*/

#ifndef UBICOM32_CPU_H
#define UBICOM32_CPU_H

#include "opcode/cgen-bitset.h"

#define CGEN_ARCH ubicom32

/* Given symbol S, return ubicom32_cgen_<S>.  */
#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define CGEN_SYM(s) ubicom32##_cgen_##s
#else
#define CGEN_SYM(s) ubicom32/**/_cgen_/**/s
#endif


/* Selected cpu families.  */
#define HAVE_CPU_UBICOM32BF

#define CGEN_INSN_LSB0_P 1

/* Minimum size of any insn (in bytes).  */
#define CGEN_MIN_INSN_SIZE 4

/* Maximum size of any insn (in bytes).  */
#define CGEN_MAX_INSN_SIZE 4

#define CGEN_INT_INSN_P 1

/* Maximum number of syntax elements in an instruction.  */
#define CGEN_ACTUAL_MAX_SYNTAX_ELEMENTS 27

/* CGEN_MNEMONIC_OPERANDS is defined if mnemonics have operands.
   e.g. In "b,a foo" the ",a" is an operand.  If mnemonics have operands
   we can't hash on everything up to the space.  */
#define CGEN_MNEMONIC_OPERANDS

/* Maximum number of fields in an instruction.  */
#define CGEN_ACTUAL_MAX_IFMT_OPERANDS 15

/* Enums.  */

/* Enum declaration for insn format enums for moveai.  */
typedef enum insn_opmoveai {
  OP_MOVEAI_MOVEAI = 14
} INSN_OPMOVEAI;

/* Enum declaration for insn format enums.  */
typedef enum insn_op1 {
  OP_X0, OP_X1, OP_X2, OP_FPU
 , OP_BSET, OP_BCLR, OP_DSP, OP_UNUSED_07
 , OP_AND_2, OP_AND_4, OP_OR_2, OP_OR_4
 , OP_XOR_2, OP_XOR_4, OP_ADD_2, OP_ADD_4
 , OP_ADDC, OP_SUB_2, OP_SUB_4, OP_SUBC
 , OP_PXBLEND, OP_PXVI, OP_PXADDS, OP_UNUSED_17
 , OP_CMPI, OP_MOVEI, OP_JMP, OP_CALL
 , OP_MOVEAI, OP_MOVEAIH, OP_X1E, OP_UNUSED_1F
} INSN_OP1;

/* Enum declaration for insn x0 opcode ext enums.  */
typedef enum insn_op2 {
  OPX0_UNUSED_00, OPX0_SUSPEND, OPX0_FLUSH, OPX0_SYNC
 , OPX0_RET, OPX0_PREFETCH, OPX0_IREAD_TBTST, OPX0_BKPT
 , OPX0_SYSRET, OPX0_SYSCALL, OPX0_NOT_4, OPX0_NOT_2
 , OPX0_MOVE_4, OPX0_MOVE_2, OPX0_MOVEA, OPX0_MOVE_1
 , OPX0_IWRITE_TBREST, OPX0_FLUSHNI, OPX0_SETCSR, OPX0_TBSET
 , OPX0_TBCLR, OPX0_EXT_2, OPX0_INVAL, OPX0_EXT_1
 , OPX0_SWAPB_2, OPX0_SWAPB_4, OPX0_PXCNV, OPX0_PXCNV_T
 , OPX0_LEA_4, OPX0_LEA_2, OPX0_PDEC, OPX0_LEA_1
} INSN_OP2;

/* Enum declaration for insn x01 opcode ext enums.  */
typedef enum insn_x01 {
  OPX01_MOVEIO_4, OPX01_MOVEIO_2, OPX01_MOVEIO_1, OPX01_UNUSED_03
 , OPX01_UNUSED_04, OPX01_UNUSED_05, OPX01_UNUSED_06, OPX01_UNUSED_07
 , OPX01_UNUSED_08, OPX01_UNUSED_09, OPX01_UNUSED_0A, OPX01_UNUSED_0B
 , OPX01_UNUSED_0C, OPX01_UNUSED_0D, OPX01_UNUSED_0E, OPX01_UNUSED_0F
 , OPX01_UNUSED_10, OPX01_UNUSED_11, OPX01_UNUSED_12, OPX01_UNUSED_13
 , OPX01_UNUSED_14, OPX01_UNUSED_15, OPX01_UNUSED_16, OPX01_UNUSED_17
 , OPX01_UNUSED_18, OPX01_UNUSED_19, OPX01_UNUSED_1A, OPX01_UNUSED_1B
 , OPX01_UNUSED_1C, OPX01_UNUSED_1D, OPX01_UNUSED_1E, OPX01_UNUSED_1F
} INSN_X01;

/* Enum declaration for insn x1E opcode ext enums.  */
typedef enum insn_x1e {
  OPX1E_CALLI, OPX1E_LEAI, OPX1E_CALLI_B, OPX1E_UNUSED_03
 , OPX1E_UNUSED_04, OPX1E_UNUSED_05, OPX1E_UNUSED_06, OPX1E_UNUSED_07
 , OPX1E_UNUSED_08, OPX1E_UNUSED_09, OPX1E_UNUSED_0A, OPX1E_UNUSED_0B
 , OPX1E_UNUSED_0C, OPX1E_UNUSED_0D, OPX1E_UNUSED_0E, OPX1E_UNUSED_0F
 , OPX1E_UNUSED_10, OPX1E_UNUSED_11, OPX1E_UNUSED_12, OPX1E_UNUSED_13
 , OPX1E_UNUSED_14, OPX1E_UNUSED_15, OPX1E_UNUSED_16, OPX1E_UNUSED_17
 , OPX1E_UNUSED_18, OPX1E_UNUSED_19, OPX1E_UNUSED_1A, OPX1E_UNUSED_1B
 , OPX1E_UNUSED_1C, OPX1E_UNUSED_1D, OPX1E_UNUSED_1E, OPX1E_UNUSED_1F
} INSN_X1E;

/* Enum declaration for insn x2 opcode ext enums.  */
typedef enum insn_opext {
  OPX2_PXHI, OPX2_MULS, OPX2_PXHI_S, OPX2_MULU
 , OPX2_UNUSED_04, OPX2_MULF, OPX2_BTST, OPX2_UNUSED_07
 , OPX2_CRCGEN, OPX2_MAC, OPX2_LSL_1, OPX2_LSR_1
 , OPX2_ASR_1, OPX2_UNUSED_0D, OPX2_UNUSED_0E, OPX2_UNUSED_0F
 , OPX2_LSL_4, OPX2_LSL_2, OPX2_LSR_4, OPX2_LSR_2
 , OPX2_ASR_4, OPX2_ASR_2, OPX2_BFEXTU, OPX2_UNUSED_17
 , OPX2_BFRVRS, OPX2_UNUSED_19, OPX2_SHFTD, OPX2_UNUSED_1B
 , OPX2_MERGE, OPX2_UNUSED_1D, OPX2_SHMRG_2, OPX2_SHMRG_1
} INSN_OPEXT;

/* Enum declaration for insn dsp opcode ext enums.  */
typedef enum insn_dsp_subop {
  OPDSP_MULS, OPDSP_MACS, OPDSP_MULU, OPDSP_MACU
 , OPDSP_MULF, OPDSP_MACF, OPDSP_MACS_4, OPDSP_MACUS
 , OPDSP_MULS_4, OPDSP_MSUF, OPDSP_MULU_4, OPDSP_MACU_4
 , OPDSP_UNUSED_0C, OPDSP_UNUSED_0D, OPDSP_UNUSED_0E, OPDSP_UNUSED_0F
 , OPDSP_MADD_4, OPDSP_MADD_2, OPDSP_MSUB_4, OPDSP_MSUB_2
 , OPDSP_UNUSED_14, OPDSP_UNUSED_15, OPDSP_UNUSED_16, OPDSP_UNUSED_17
 , OPDSP_UNUSED_18, OPDSP_UNUSED_19, OPDSP_UNUSED_1A, OPDSP_UNUSED_1B
 , OPDSP_UNUSED_1C, OPDSP_UNUSED_1D, OPDSP_UNUSED_1E, OPDSP_UNUSED_1F
} INSN_DSP_SUBOP;

/* Enum declaration for insn FPU opcode ext enums.  */
typedef enum insn_fpu_subop {
  OPFPU_FADDS, OPFPU_FSUBS, OPFPU_FMULS, OPFPU_FDIVS
 , OPFPU_FI2D, OPFPU_FS2D, OPFPU_FS2L, OPFPU_FSQRTS
 , OPFPU_FNEGS, OPFPU_FABSS, OPFPU_FI2S, OPFPU_FS2I
 , OPFPU_FCMPS, OPFPU_UNUSED_0D, OPFPU_UNUSED_0E, OPFPU_UNUSED_0F
 , OPFPU_FADDD, OPFPU_FSUBD, OPFPU_FMULD, OPFPU_FDIVD
 , OPFPU_FL2S, OPFPU_FD2S, OPFPU_FD2I, OPFPU_FSQRTD
 , OPFPU_FNEGD, OPFPU_FABSD, OPFPU_FL2D, OPFPU_FD2L
 , OPFPU_FCMPD, OPFPU_UNUSED_1D, OPFPU_UNUSED_1E, OPFPU_UNUSED_1F
} INSN_FPU_SUBOP;

/* Enum declaration for .  */
typedef enum data_names {
  H_DR_D0, H_DR_D1, H_DR_D2, H_DR_D3
 , H_DR_D4, H_DR_D5, H_DR_D6, H_DR_D7
 , H_DR_D8, H_DR_D9, H_DR_D10, H_DR_D11
 , H_DR_D12, H_DR_D13, H_DR_D14, H_DR_D15
} DATA_NAMES;

/* Enum declaration for .  */
typedef enum addr_names {
  H_AR_SP = 7, H_AR_A0 = 0, H_AR_A1 = 1, H_AR_A2 = 2
 , H_AR_A3 = 3, H_AR_A4 = 4, H_AR_A5 = 5, H_AR_A6 = 6
 , H_AR_A7 = 7
} ADDR_NAMES;

/* Enum declaration for .  */
typedef enum acc_names {
  ACCS_ACC0, ACCS_ACC1
} ACC_NAMES;

/* Enum declaration for .  */
typedef enum acc_lo_names {
  ACC_LOS_ACC0_LO, ACC_LOS_ACC0_HI, ACC_LOS_ACC1_LO, ACC_LOS_ACC1_HI
} ACC_LO_NAMES;

/* Enum declaration for .  */
typedef enum data_names_even {
  H_DR_EVEN_D0, H_DR_EVEN_D2, H_DR_EVEN_D4, H_DR_EVEN_D6
 , H_DR_EVEN_D8, H_DR_EVEN_D10, H_DR_EVEN_D12, H_DR_EVEN_D14
} DATA_NAMES_EVEN;

/* Enum declaration for .  */
typedef enum spad_names {
  H_SP_SCRATCHPAD0 = 0, H_SP_SCRATCHPAD1 = 0, H_SP_SCRATCHPAD2 = 0, H_SP_SCRATCHPAD3 = 0
 , H_SP_SCRATCHPAD4 = 0, H_SP_SCRATCHPAD5 = 0
} SPAD_NAMES;

/* Attributes.  */

/* Enum declaration for machine type selection.  */
typedef enum mach_attr {
  MACH_BASE, MACH_IP3035, MACH_UBICOM32DSP, MACH_IP3023COMPATIBILITY
 , MACH_UBICOM32_VER4, MACH_UBICOM32_VER5, MACH_UBICOM32_OLDMOVEAI, MACH_UBICOM32_NEWMOVEAI
 , MACH_UBICOM32_NEWMOVEAISIMULATE, MACH_UBICOM32_VER6, MACH_MAX
} MACH_ATTR;

/* Enum declaration for instruction set selection.  */
typedef enum isa_attr {
  ISA_UBICOM32, ISA_MAX
} ISA_ATTR;

/* Number of architecture variants.  */
#define MAX_ISAS  1
#define MAX_MACHS ((int) MACH_MAX)

/* Ifield support.  */

/* Ifield attribute indices.  */

/* Enum declaration for cgen_ifld attrs.  */
typedef enum cgen_ifld_attr {
  CGEN_IFLD_VIRTUAL, CGEN_IFLD_PCREL_ADDR, CGEN_IFLD_ABS_ADDR, CGEN_IFLD_RESERVED
 , CGEN_IFLD_SIGN_OPT, CGEN_IFLD_SIGNED, CGEN_IFLD_END_BOOLS, CGEN_IFLD_START_NBOOLS = 31
 , CGEN_IFLD_MACH, CGEN_IFLD_END_NBOOLS
} CGEN_IFLD_ATTR;

/* Number of non-boolean elements in cgen_ifld_attr.  */
#define CGEN_IFLD_NBOOL_ATTRS (CGEN_IFLD_END_NBOOLS - CGEN_IFLD_START_NBOOLS - 1)

/* cgen_ifld attribute accessor macros.  */
#define CGEN_ATTR_CGEN_IFLD_MACH_VALUE(attrs) ((attrs)->nonbool[CGEN_IFLD_MACH-CGEN_IFLD_START_NBOOLS-1].nonbitset)
#define CGEN_ATTR_CGEN_IFLD_VIRTUAL_VALUE(attrs) (((attrs)->bool & (1 << CGEN_IFLD_VIRTUAL)) != 0)
#define CGEN_ATTR_CGEN_IFLD_PCREL_ADDR_VALUE(attrs) (((attrs)->bool & (1 << CGEN_IFLD_PCREL_ADDR)) != 0)
#define CGEN_ATTR_CGEN_IFLD_ABS_ADDR_VALUE(attrs) (((attrs)->bool & (1 << CGEN_IFLD_ABS_ADDR)) != 0)
#define CGEN_ATTR_CGEN_IFLD_RESERVED_VALUE(attrs) (((attrs)->bool & (1 << CGEN_IFLD_RESERVED)) != 0)
#define CGEN_ATTR_CGEN_IFLD_SIGN_OPT_VALUE(attrs) (((attrs)->bool & (1 << CGEN_IFLD_SIGN_OPT)) != 0)
#define CGEN_ATTR_CGEN_IFLD_SIGNED_VALUE(attrs) (((attrs)->bool & (1 << CGEN_IFLD_SIGNED)) != 0)

/* Enum declaration for ubicom32 ifield types.  */
typedef enum ifield_type {
  UBICOM32_F_NIL, UBICOM32_F_ANYOF, UBICOM32_F_D, UBICOM32_F_D_BIT10
 , UBICOM32_F_D_TYPE, UBICOM32_F_D_R, UBICOM32_F_D_M, UBICOM32_F_D_I4_1
 , UBICOM32_F_D_I4_2, UBICOM32_F_D_I4_4, UBICOM32_F_D_AN, UBICOM32_F_D_DIRECT
 , UBICOM32_F_D_IMM8, UBICOM32_F_D_IMM7_T, UBICOM32_F_D_IMM7_B, UBICOM32_F_D_IMM7_1
 , UBICOM32_F_D_IMM7_2, UBICOM32_F_D_IMM7_4, UBICOM32_F_S1, UBICOM32_F_S1_BIT10
 , UBICOM32_F_S1_TYPE, UBICOM32_F_S1_R, UBICOM32_F_S1_M, UBICOM32_F_S1_I4_1
 , UBICOM32_F_S1_I4_2, UBICOM32_F_S1_I4_4, UBICOM32_F_S1_AN, UBICOM32_F_S1_DIRECT
 , UBICOM32_F_S1_IMM8, UBICOM32_F_S1_IMM7_T, UBICOM32_F_S1_IMM7_B, UBICOM32_F_S1_IMM7_1
 , UBICOM32_F_S1_IMM7_2, UBICOM32_F_S1_IMM7_4, UBICOM32_F_OP1, UBICOM32_F_OPMOVEAI
 , UBICOM32_F_OP2, UBICOM32_F_BIT26, UBICOM32_F_OPEXT, UBICOM32_F_COND
 , UBICOM32_F_IMM16_1, UBICOM32_F_IMM16_2, UBICOM32_F_O21, UBICOM32_F_O23_21
 , UBICOM32_F_O20_0, UBICOM32_F_O24, UBICOM32_F_IMM23_21, UBICOM32_F_IMM24
 , UBICOM32_F_IMM24_21, UBICOM32_F_IMM25, UBICOM32_F_O15_13, UBICOM32_F_O12_8
 , UBICOM32_F_O7_5, UBICOM32_F_O4_0, UBICOM32_F_O16, UBICOM32_F_LEAI_O16
 , UBICOM32_F_AN, UBICOM32_F_AM, UBICOM32_F_DN, UBICOM32_F_BIT5
 , UBICOM32_F_P, UBICOM32_F_C, UBICOM32_F_INT, UBICOM32_F_DSP_C
 , UBICOM32_F_DSP_T, UBICOM32_F_DSP_S2_SEL, UBICOM32_F_DSP_R, UBICOM32_F_DSP_DESTA
 , UBICOM32_F_DSP_B15, UBICOM32_F_DSP_S2, UBICOM32_F_DSP_J, UBICOM32_F_S2
 , UBICOM32_F_B15, UBICOM32_F_BIT0, UBICOM32_F_BIT16, UBICOM32_F_FPUNUSED20
 , UBICOM32_F_FPUNUSED15, UBICOM32_F_FPUNUSED11, UBICOM32_F_FPD32, UBICOM32_F_FPD64
 , UBICOM32_F_FPS2_SEL, UBICOM32_F_FPS2_REG32, UBICOM32_F_FPS232, UBICOM32_F_FPS2_REG64
 , UBICOM32_F_FPS264, UBICOM32_F_FPS1_SEL, UBICOM32_F_FPS1_REG64, UBICOM32_F_FPS164
 , UBICOM32_F_MAX
} IFIELD_TYPE;

#define MAX_IFLD ((int) UBICOM32_F_MAX)

/* Hardware attribute indices.  */

/* Enum declaration for cgen_hw attrs.  */
typedef enum cgen_hw_attr {
  CGEN_HW_VIRTUAL, CGEN_HW_CACHE_ADDR, CGEN_HW_PC, CGEN_HW_PROFILE
 , CGEN_HW_END_BOOLS, CGEN_HW_START_NBOOLS = 31, CGEN_HW_MACH, CGEN_HW_END_NBOOLS
} CGEN_HW_ATTR;

/* Number of non-boolean elements in cgen_hw_attr.  */
#define CGEN_HW_NBOOL_ATTRS (CGEN_HW_END_NBOOLS - CGEN_HW_START_NBOOLS - 1)

/* cgen_hw attribute accessor macros.  */
#define CGEN_ATTR_CGEN_HW_MACH_VALUE(attrs) ((attrs)->nonbool[CGEN_HW_MACH-CGEN_HW_START_NBOOLS-1].nonbitset)
#define CGEN_ATTR_CGEN_HW_VIRTUAL_VALUE(attrs) (((attrs)->bool & (1 << CGEN_HW_VIRTUAL)) != 0)
#define CGEN_ATTR_CGEN_HW_CACHE_ADDR_VALUE(attrs) (((attrs)->bool & (1 << CGEN_HW_CACHE_ADDR)) != 0)
#define CGEN_ATTR_CGEN_HW_PC_VALUE(attrs) (((attrs)->bool & (1 << CGEN_HW_PC)) != 0)
#define CGEN_ATTR_CGEN_HW_PROFILE_VALUE(attrs) (((attrs)->bool & (1 << CGEN_HW_PROFILE)) != 0)

/* Enum declaration for ubicom32 hardware types.  */
typedef enum cgen_hw_type {
  HW_H_MEMORY, HW_H_SINT, HW_H_UINT, HW_H_ADDR
 , HW_H_IADDR, HW_H_GLOBAL_CONTROL, HW_H_MT_BREAK, HW_H_MT_ACTIVE
 , HW_H_MT_ENABLE, HW_H_MT_PRIORITY, HW_H_MT_SCHEDULE, HW_H_IRQ_STATUS_0
 , HW_H_IRQ_STATUS_1, HW_H_DR, HW_H_S1_DR, HW_H_AR
 , HW_H_AR_INC, HW_H_AR_INC_FLAG, HW_H_MAC_HI, HW_H_MAC_LO
 , HW_H_SRC_3, HW_H_CSR, HW_H_IREAD, HW_H_ACC1_HI
 , HW_H_ACC1_LO, HW_H_PC, HW_H_NBIT_16, HW_H_ZBIT_16
 , HW_H_VBIT_16, HW_H_CBIT_16, HW_H_NBIT_32, HW_H_ZBIT_32
 , HW_H_VBIT_32, HW_H_CBIT_32, HW_H_PREV_PRIVBIT, HW_H_PRIVBIT
 , HW_H_CC, HW_H_C, HW_H_P, HW_H_DSP_C
 , HW_H_FPU_ACC_LO_32, HW_H_DSP_T, HW_H_DSP_T_ADDSUB, HW_H_DSP_DEST_A
 , HW_H_DSP_S2_ACC_REG_MUL, HW_H_DSP_S2_ACC_REG_ADDSUB, HW_H_FPU_ACC_64, HW_H_FPU_ACC_32
 , HW_H_FPU_DATA_REG_32, HW_H_FPU_DATA_REG_64, HW_H_SP, HW_MAX
} CGEN_HW_TYPE;

#define MAX_HW ((int) HW_MAX)

/* Operand attribute indices.  */

/* Enum declaration for cgen_operand attrs.  */
typedef enum cgen_operand_attr {
  CGEN_OPERAND_VIRTUAL, CGEN_OPERAND_PCREL_ADDR, CGEN_OPERAND_ABS_ADDR, CGEN_OPERAND_SIGN_OPT
 , CGEN_OPERAND_SIGNED, CGEN_OPERAND_NEGATIVE, CGEN_OPERAND_RELAX, CGEN_OPERAND_SEM_ONLY
 , CGEN_OPERAND_END_BOOLS, CGEN_OPERAND_START_NBOOLS = 31, CGEN_OPERAND_MACH, CGEN_OPERAND_END_NBOOLS
} CGEN_OPERAND_ATTR;

/* Number of non-boolean elements in cgen_operand_attr.  */
#define CGEN_OPERAND_NBOOL_ATTRS (CGEN_OPERAND_END_NBOOLS - CGEN_OPERAND_START_NBOOLS - 1)

/* cgen_operand attribute accessor macros.  */
#define CGEN_ATTR_CGEN_OPERAND_MACH_VALUE(attrs) ((attrs)->nonbool[CGEN_OPERAND_MACH-CGEN_OPERAND_START_NBOOLS-1].nonbitset)
#define CGEN_ATTR_CGEN_OPERAND_VIRTUAL_VALUE(attrs) (((attrs)->bool & (1 << CGEN_OPERAND_VIRTUAL)) != 0)
#define CGEN_ATTR_CGEN_OPERAND_PCREL_ADDR_VALUE(attrs) (((attrs)->bool & (1 << CGEN_OPERAND_PCREL_ADDR)) != 0)
#define CGEN_ATTR_CGEN_OPERAND_ABS_ADDR_VALUE(attrs) (((attrs)->bool & (1 << CGEN_OPERAND_ABS_ADDR)) != 0)
#define CGEN_ATTR_CGEN_OPERAND_SIGN_OPT_VALUE(attrs) (((attrs)->bool & (1 << CGEN_OPERAND_SIGN_OPT)) != 0)
#define CGEN_ATTR_CGEN_OPERAND_SIGNED_VALUE(attrs) (((attrs)->bool & (1 << CGEN_OPERAND_SIGNED)) != 0)
#define CGEN_ATTR_CGEN_OPERAND_NEGATIVE_VALUE(attrs) (((attrs)->bool & (1 << CGEN_OPERAND_NEGATIVE)) != 0)
#define CGEN_ATTR_CGEN_OPERAND_RELAX_VALUE(attrs) (((attrs)->bool & (1 << CGEN_OPERAND_RELAX)) != 0)
#define CGEN_ATTR_CGEN_OPERAND_SEM_ONLY_VALUE(attrs) (((attrs)->bool & (1 << CGEN_OPERAND_SEM_ONLY)) != 0)

/* Enum declaration for ubicom32 operand types.  */
typedef enum cgen_operand_type {
  UBICOM32_OPERAND_PC, UBICOM32_OPERAND_S2, UBICOM32_OPERAND_SRC3, UBICOM32_OPERAND_OFFSET24
 , UBICOM32_OPERAND_AN, UBICOM32_OPERAND_CC, UBICOM32_OPERAND_C, UBICOM32_OPERAND_P
 , UBICOM32_OPERAND_AM, UBICOM32_OPERAND_DN, UBICOM32_OPERAND_INTERRUPT, UBICOM32_OPERAND_IMM16_1
 , UBICOM32_OPERAND_X_OP2, UBICOM32_OPERAND_X_BIT26, UBICOM32_OPERAND_X_S1, UBICOM32_OPERAND_X_D
 , UBICOM32_OPERAND_X_DN, UBICOM32_OPERAND_MACHI, UBICOM32_OPERAND_MACLO, UBICOM32_OPERAND_ACC1HI
 , UBICOM32_OPERAND_ACC1LO, UBICOM32_OPERAND_IRQ_0, UBICOM32_OPERAND_IRQ_1, UBICOM32_OPERAND_IREAD
 , UBICOM32_OPERAND_OPC1, UBICOM32_OPERAND_OPC2, UBICOM32_OPERAND_AN_INC, UBICOM32_OPERAND_DSP_C
 , UBICOM32_OPERAND_DSP_T, UBICOM32_OPERAND_DSP_DESTA, UBICOM32_OPERAND_DSP_S2_SEL, UBICOM32_OPERAND_DSP_S2_DATA_REG
 , UBICOM32_OPERAND_DSP_S2_ACC_REG_MUL, UBICOM32_OPERAND_DSP_S2_ACC_REG_ADDSUB, UBICOM32_OPERAND_DSP_S2_DATA_REG_ADDSUB, UBICOM32_OPERAND_DSP_T_ADDSUB
 , UBICOM32_OPERAND_BIT5, UBICOM32_OPERAND_BIT5_ADDSUB, UBICOM32_OPERAND_FPU_32_S2_DATA_REG, UBICOM32_OPERAND_FPU_32_S2_ACC_REG
 , UBICOM32_OPERAND_FPU_64_S2_DATA_REG, UBICOM32_OPERAND_FPU_64_S2_ACC_REG, UBICOM32_OPERAND_FPU_64_S1_DATA_REG, UBICOM32_OPERAND_FPU_64_S1_ACC_REG
 , UBICOM32_OPERAND_FPU_32_DEST_REG, UBICOM32_OPERAND_FPU_64_DEST_REG, UBICOM32_OPERAND_FPU_32_SRC2_DATA_REG, UBICOM32_OPERAND_FPU_32_SRC2_ACC_REG
 , UBICOM32_OPERAND_DSP_SRC2_REG_ACC_REG_MUL, UBICOM32_OPERAND_DSP_SRC2_REG_ACC_REG_ADDSUB, UBICOM32_OPERAND_DSP_SRC2_DATA_REG, UBICOM32_OPERAND_DSP_SRC2_DATA_REG_ADDSUB
 , UBICOM32_OPERAND_DSP_SRC2_DATA_REG_ADDSUB2, UBICOM32_OPERAND_DSP_IMM_BIT5, UBICOM32_OPERAND_DSP_IMM_BIT5_ADDSUB, UBICOM32_OPERAND_DSP_IMM_BIT5_ADDSUB2
 , UBICOM32_OPERAND_IMM_BIT5, UBICOM32_OPERAND_DYN_REG, UBICOM32_OPERAND_OP3, UBICOM32_OPERAND_DSP_SRC2_MUL
 , UBICOM32_OPERAND_DSP_COMPATIBILITY_SRC2_MUL, UBICOM32_OPERAND_DSP_SRC2_ADDSUB, UBICOM32_OPERAND_DSP_SRC2_ADDSUB2, UBICOM32_OPERAND_OFFSET21
 , UBICOM32_OPERAND_OFFSET16, UBICOM32_OPERAND_LEAI_OFFSET16, UBICOM32_OPERAND_IMM24, UBICOM32_OPERAND_IMM25
 , UBICOM32_OPERAND_NBIT_16, UBICOM32_OPERAND_VBIT_16, UBICOM32_OPERAND_ZBIT_16, UBICOM32_OPERAND_CBIT_16
 , UBICOM32_OPERAND_NBIT_32, UBICOM32_OPERAND_VBIT_32, UBICOM32_OPERAND_ZBIT_32, UBICOM32_OPERAND_CBIT_32
 , UBICOM32_OPERAND_PRIVILEGE_BIT, UBICOM32_OPERAND_PREV_PRIVILEGE_BIT, UBICOM32_OPERAND_S1_IMM7_1, UBICOM32_OPERAND_S1_IMM7_2
 , UBICOM32_OPERAND_S1_IMM7_4, UBICOM32_OPERAND_PDEC_S1_IMM7_4, UBICOM32_OPERAND_S1_IMM8, UBICOM32_OPERAND_S1_AN
 , UBICOM32_OPERAND_S1_R, UBICOM32_OPERAND_S1_AN_INC, UBICOM32_OPERAND_S1_I4_1, UBICOM32_OPERAND_S1_I4_2
 , UBICOM32_OPERAND_S1_I4_4, UBICOM32_OPERAND_S1_INDIRECT_1, UBICOM32_OPERAND_S1_INDIRECT_2, UBICOM32_OPERAND_S1_INDIRECT_4
 , UBICOM32_OPERAND_S1_INDIRECT_WITH_OFFSET_1, UBICOM32_OPERAND_S1_INDIRECT_WITH_OFFSET_2, UBICOM32_OPERAND_S1_INDIRECT_WITH_OFFSET_4, UBICOM32_OPERAND_S1_INDIRECT_WITH_INDEX_1
 , UBICOM32_OPERAND_S1_INDIRECT_WITH_INDEX_2, UBICOM32_OPERAND_S1_INDIRECT_WITH_INDEX_4, UBICOM32_OPERAND_S1_INDIRECT_WITH_POST_INCREMENT_1, UBICOM32_OPERAND_S1_INDIRECT_WITH_POST_INCREMENT_2
 , UBICOM32_OPERAND_S1_INDIRECT_WITH_POST_INCREMENT_4, UBICOM32_OPERAND_S1_INDIRECT_WITH_PRE_INCREMENT_1, UBICOM32_OPERAND_S1_INDIRECT_WITH_PRE_INCREMENT_2, UBICOM32_OPERAND_S1_INDIRECT_WITH_PRE_INCREMENT_4
 , UBICOM32_OPERAND_S1_DIRECT_ADDR, UBICOM32_OPERAND_S1_DIRECT, UBICOM32_OPERAND_S1_IMMEDIATE, UBICOM32_OPERAND_S1_1
 , UBICOM32_OPERAND_S1_2, UBICOM32_OPERAND_S1_4, UBICOM32_OPERAND_S1_EA_INDIRECT, UBICOM32_OPERAND_S1_EA_INDIRECT_WITH_OFFSET_1
 , UBICOM32_OPERAND_S1_EA_INDIRECT_WITH_OFFSET_2, UBICOM32_OPERAND_S1_EA_INDIRECT_WITH_OFFSET_4, UBICOM32_OPERAND_S1_EA_INDIRECT_WITH_INDEX_1, UBICOM32_OPERAND_S1_EA_INDIRECT_WITH_INDEX_2
 , UBICOM32_OPERAND_S1_EA_INDIRECT_WITH_INDEX_4, UBICOM32_OPERAND_S1_EA_INDIRECT_WITH_POST_INCREMENT_1, UBICOM32_OPERAND_S1_EA_INDIRECT_WITH_POST_INCREMENT_2, UBICOM32_OPERAND_S1_EA_INDIRECT_WITH_POST_INCREMENT_4
 , UBICOM32_OPERAND_S1_EA_INDIRECT_WITH_PRE_INCREMENT_1, UBICOM32_OPERAND_S1_EA_INDIRECT_WITH_PRE_INCREMENT_2, UBICOM32_OPERAND_S1_EA_INDIRECT_WITH_PRE_INCREMENT_4, UBICOM32_OPERAND_S1_EA_IMMEDIATE
 , UBICOM32_OPERAND_S1_EA_DIRECT, UBICOM32_OPERAND_S1_EA_1, UBICOM32_OPERAND_S1_EA_2, UBICOM32_OPERAND_S1_EA_4
 , UBICOM32_OPERAND_S1_PEA, UBICOM32_OPERAND_PDEC_S1_EA_INDIRECT_WITH_OFFSET_4, UBICOM32_OPERAND_PDEC_PEA_S1, UBICOM32_OPERAND_D_IMM7_1
 , UBICOM32_OPERAND_D_IMM7_2, UBICOM32_OPERAND_D_IMM7_4, UBICOM32_OPERAND_D_IMM8, UBICOM32_OPERAND_D_AN
 , UBICOM32_OPERAND_D_R, UBICOM32_OPERAND_D_AN_INC, UBICOM32_OPERAND_D_I4_1, UBICOM32_OPERAND_D_I4_2
 , UBICOM32_OPERAND_D_I4_4, UBICOM32_OPERAND_D_INDIRECT_1, UBICOM32_OPERAND_D_INDIRECT_2, UBICOM32_OPERAND_D_INDIRECT_4
 , UBICOM32_OPERAND_D_INDIRECT_WITH_OFFSET_1, UBICOM32_OPERAND_D_INDIRECT_WITH_OFFSET_2, UBICOM32_OPERAND_D_INDIRECT_WITH_OFFSET_4, UBICOM32_OPERAND_D_INDIRECT_WITH_INDEX_1
 , UBICOM32_OPERAND_D_INDIRECT_WITH_INDEX_2, UBICOM32_OPERAND_D_INDIRECT_WITH_INDEX_4, UBICOM32_OPERAND_D_INDIRECT_WITH_POST_INCREMENT_1, UBICOM32_OPERAND_D_INDIRECT_WITH_POST_INCREMENT_2
 , UBICOM32_OPERAND_D_INDIRECT_WITH_POST_INCREMENT_4, UBICOM32_OPERAND_D_INDIRECT_WITH_PRE_INCREMENT_1, UBICOM32_OPERAND_D_INDIRECT_WITH_PRE_INCREMENT_2, UBICOM32_OPERAND_D_INDIRECT_WITH_PRE_INCREMENT_4
 , UBICOM32_OPERAND_D_DIRECT_ADDR, UBICOM32_OPERAND_D_DIRECT, UBICOM32_OPERAND_D_IMMEDIATE_1, UBICOM32_OPERAND_D_IMMEDIATE_2
 , UBICOM32_OPERAND_D_IMMEDIATE_4, UBICOM32_OPERAND_D_1, UBICOM32_OPERAND_D_2, UBICOM32_OPERAND_D_4
 , UBICOM32_OPERAND_D_PEA_INDIRECT, UBICOM32_OPERAND_D_PEA_INDIRECT_WITH_OFFSET, UBICOM32_OPERAND_D_PEA_INDIRECT_WITH_POST_INCREMENT, UBICOM32_OPERAND_D_PEA_INDIRECT_WITH_PRE_INCREMENT
 , UBICOM32_OPERAND_D_PEA_INDIRECT_WITH_INDEX, UBICOM32_OPERAND_D_PEA, UBICOM32_OPERAND_IMM16_2, UBICOM32_OPERAND_MAX
} CGEN_OPERAND_TYPE;

/* Number of operands types.  */
#define MAX_OPERANDS 171

/* Maximum number of operands referenced by any insn.  */
#define MAX_OPERAND_INSTANCES 8

/* Insn attribute indices.  */

/* Enum declaration for cgen_insn attrs.  */
typedef enum cgen_insn_attr {
  CGEN_INSN_ALIAS, CGEN_INSN_VIRTUAL, CGEN_INSN_UNCOND_CTI, CGEN_INSN_COND_CTI
 , CGEN_INSN_SKIP_CTI, CGEN_INSN_DELAY_SLOT, CGEN_INSN_RELAXABLE, CGEN_INSN_RELAXED
 , CGEN_INSN_NO_DIS, CGEN_INSN_PBB, CGEN_INSN_END_BOOLS, CGEN_INSN_START_NBOOLS = 31
 , CGEN_INSN_MACH, CGEN_INSN_END_NBOOLS
} CGEN_INSN_ATTR;

/* Number of non-boolean elements in cgen_insn_attr.  */
#define CGEN_INSN_NBOOL_ATTRS (CGEN_INSN_END_NBOOLS - CGEN_INSN_START_NBOOLS - 1)

/* cgen_insn attribute accessor macros.  */
#define CGEN_ATTR_CGEN_INSN_MACH_VALUE(attrs) ((attrs)->nonbool[CGEN_INSN_MACH-CGEN_INSN_START_NBOOLS-1].nonbitset)
#define CGEN_ATTR_CGEN_INSN_ALIAS_VALUE(attrs) (((attrs)->bool & (1 << CGEN_INSN_ALIAS)) != 0)
#define CGEN_ATTR_CGEN_INSN_VIRTUAL_VALUE(attrs) (((attrs)->bool & (1 << CGEN_INSN_VIRTUAL)) != 0)
#define CGEN_ATTR_CGEN_INSN_UNCOND_CTI_VALUE(attrs) (((attrs)->bool & (1 << CGEN_INSN_UNCOND_CTI)) != 0)
#define CGEN_ATTR_CGEN_INSN_COND_CTI_VALUE(attrs) (((attrs)->bool & (1 << CGEN_INSN_COND_CTI)) != 0)
#define CGEN_ATTR_CGEN_INSN_SKIP_CTI_VALUE(attrs) (((attrs)->bool & (1 << CGEN_INSN_SKIP_CTI)) != 0)
#define CGEN_ATTR_CGEN_INSN_DELAY_SLOT_VALUE(attrs) (((attrs)->bool & (1 << CGEN_INSN_DELAY_SLOT)) != 0)
#define CGEN_ATTR_CGEN_INSN_RELAXABLE_VALUE(attrs) (((attrs)->bool & (1 << CGEN_INSN_RELAXABLE)) != 0)
#define CGEN_ATTR_CGEN_INSN_RELAXED_VALUE(attrs) (((attrs)->bool & (1 << CGEN_INSN_RELAXED)) != 0)
#define CGEN_ATTR_CGEN_INSN_NO_DIS_VALUE(attrs) (((attrs)->bool & (1 << CGEN_INSN_NO_DIS)) != 0)
#define CGEN_ATTR_CGEN_INSN_PBB_VALUE(attrs) (((attrs)->bool & (1 << CGEN_INSN_PBB)) != 0)

/* cgen.h uses things we just defined.  */
#include "opcode/cgen.h"

extern const struct cgen_ifld ubicom32_cgen_ifld_table[];

/* Attributes.  */
extern const CGEN_ATTR_TABLE ubicom32_cgen_hardware_attr_table[];
extern const CGEN_ATTR_TABLE ubicom32_cgen_ifield_attr_table[];
extern const CGEN_ATTR_TABLE ubicom32_cgen_operand_attr_table[];
extern const CGEN_ATTR_TABLE ubicom32_cgen_insn_attr_table[];

/* Hardware decls.  */

extern CGEN_KEYWORD ubicom32_cgen_opval_data_names;
extern CGEN_KEYWORD ubicom32_cgen_opval_data_names;
extern CGEN_KEYWORD ubicom32_cgen_opval_addr_names;
extern CGEN_KEYWORD ubicom32_cgen_opval_h_cc;
extern CGEN_KEYWORD ubicom32_cgen_opval_h_C;
extern CGEN_KEYWORD ubicom32_cgen_opval_h_P;
extern CGEN_KEYWORD ubicom32_cgen_opval_h_DSP_C;
extern CGEN_KEYWORD ubicom32_cgen_opval_h_FPU_acc_lo_32;
extern CGEN_KEYWORD ubicom32_cgen_opval_h_DSP_T;
extern CGEN_KEYWORD ubicom32_cgen_opval_h_DSP_T_addsub;
extern CGEN_KEYWORD ubicom32_cgen_opval_h_DSP_Dest_A;
extern CGEN_KEYWORD ubicom32_cgen_opval_acc_names;
extern CGEN_KEYWORD ubicom32_cgen_opval_acc_names;
extern CGEN_KEYWORD ubicom32_cgen_opval_acc_names;
extern CGEN_KEYWORD ubicom32_cgen_opval_acc_lo_names;
extern CGEN_KEYWORD ubicom32_cgen_opval_data_names;
extern CGEN_KEYWORD ubicom32_cgen_opval_data_names_even;
extern CGEN_KEYWORD ubicom32_cgen_opval_spad_names;

extern const CGEN_HW_ENTRY ubicom32_cgen_hw_table[];



#endif /* UBICOM32_CPU_H */
